# -*- coding: utf-8 -*-

import sys
import time
import math
from PyQt4.QtCore import *
from PyQt4.QtGui import *
from PyQt4.uic import *
from types import *

class Tracker(QObject):
    def eventFilter(self, receiver, event):
        if event.type() == QEvent.MouseMove:
            track.append( (event.x(), event.y(), time.clock()) )
            w.label_2.setText(str(event.x()) + " " + str(event.y()) + " " + str(len(track)))
        return False

def showDiagram(istAn):
    if istAn:
        w.label.show()
    else:
        w.label.hide()

pn = QPen()

br = QBrush()
br.setStyle(Qt.SolidPattern)

def paintDiagram(self, event):
    painter = QPainter(self)
    for i in range(len(track)-1):
        (x,y,t) = track[i]
        (x1,y1,t1) = track[i+1]
        dt = t1 - t
        v = math.sqrt((x1-x)**2 + (y1-y)**2)/(dt + 0.00001)
        if v > 2000.0:
            pn.setColor(QColor(0, 0, 255, 128))
            painter.setPen(pn)
            painter.drawLine(x, y, x1, y1)
        else:
            alpha = 255.0/2.0*dt
            if alpha > 255.1:
                alpha = 255.1
            br.setColor(QColor(255, 120, 120, alpha))
            painter.setBrush(br)
            pn.setColor(Qt.transparent)
            painter.setPen(pn)
            painter.drawEllipse(x-40, y-40, 80, 80)

track = []

app = QApplication(sys.argv)
w = loadUi("tracker.ui")

myTracker = Tracker()
w.webView.installEventFilter(myTracker)
w.webView.setMouseTracking(True)

w.label.hide()
w.label.paintEvent = MethodType(paintDiagram, w.label)
w.connect(w.checkBox, SIGNAL("toggled(bool)"),showDiagram)

w.show()
sys.exit(app.exec_())